public class ArithmeticExpr extends Expression
  {
  public int op;                 
  public Expression left;
  public Expression right;
  
  public ArithmeticExpr(Range r, int o, Expression lt, Expression rt) 
    { super(r); op = o; left = lt; right = rt;}
  public String toString()
    { return "(" + tag() + "," + Token.spellingOf(op) + "," + left + "," + right + ")"; }

  public void visit() throws SemanticException 
    { left.visit(); right.visit(); }

  }
