public class Id extends Expression 
  {
  public String spelling;
  public int type;
  public Decl decl;
  
  public Id(Range r, String s)
    { super(r); spelling = s; }
  public String toString()
    { return tag() + " \"" + spelling + "\""; }

  public void visit() throws SemanticException
    { 
    Entry e = Global.table.lookup(spelling);
    if (e == null) throw 
      new SemanticException("`" + spelling + "' is undeclared; " + this.range + ".");
    type = e.type;
    decl = (Decl) e.node;
    }

  }
