public class IdExpr extends Id
  {
  public IdExpr(Range r, String s)
    { super(r, s); }

  public String toString()
    { return tag() + " \"" + spelling + "\""; }

   public void visit() throws SemanticException
    {
    Entry e = Global.table.lookup(spelling);
    if (e == null) throw
      new SemanticException("`" + spelling + "' is undeclared; " + this.range + ".");
    type = e.type;
    if (type == Type.PROC) throw
      new SemanticException("`" + spelling + "' is not a variable or a formal parameter; " + range + ".");
    decl = (Decl) e.node;
    }
  }
