import java.io.*;
class Main
  {
  public static void main(String[] args)
    {
    try
      {

      FileInputStream fis = new FileInputStream(args[0]);
      Lexer L = new Lexer(fis);

      Parser P = new Parser(L);
      Program p = P.parseProgram();
      
      p.visit();
      
      Indenter.print(p.toString()); 
      
      }
    catch (SemanticException e)
      {
      System.out.println(e);
      }
    catch (SyntaxException e)
      {
      System.out.println(e);
      }
    catch (IOException e)
      {
      System.out.println(e);
      }
    catch (Exception e)
      {
      e.printStackTrace();
      }
    }
  }
