class UnaryExpr extends Expression
  {
  public int op;
  public Expression child;

  public UnaryExpr(Range r, int o, Expression ct)
    { super(r); op = o; child = ct;}
 
  public String toString()
    {
    return "(" + tag() + "," + Token.spellingOf(op) + "," + child + ")"; 
    }

  public void visit() throws SemanticException
    { child.visit(); }
}
