class RelationalExpr extends Expression
  {
  public int op;                  // We use Token's enumerations.
  public Expression left;
  public Expression right;

  public RelationalExpr(Range r,int o, Expression lt, Expression rt)
    { super(r); op = o; left = lt; right = rt;}
  public String toString()
    { return "(" + tag() + "," + Token.spellingOf(op) + "," + left + "," + right + ")"; }

  public void visit() throws SemanticException
    { left.visit(); right.visit(); }

}
