public class VarDecl extends Decl
  {
  public Id name;

  public VarDecl(Range r, Id n) 
    { super(r); name = n; }
  public String toString() 
    { return "(" + tag() + "," + name + ")"; }

  public void visit() throws SemanticException
    { 
    Entry e = Global.table.lookup(name.spelling);
    if (e != null) throw new SemanticException("The name `" + name.spelling +
                                 "' at " + name.range +
                                 " was already declared.");
    Global.table.enter(name.spelling, this, Type.VAR);

    name.visit(); 
    }

  }
