public class WhileStmt extends Statement
  {
  public Expression requirement;
  public Statement body;
  
  public WhileStmt(Range r, Expression req, Statement b)
    { super(r); requirement = req; body = b; }

  public String toString()
    { return "(" + tag() +  " label:" + label + "," + requirement + "," + body + ")"; }

  public void visit() throws SemanticException
    { label = Global.nextLabel(); requirement.visit(); body.visit(); }

  }
